/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignMetrics type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignMetrics{}

// CampaignMetrics struct for CampaignMetrics
type CampaignMetrics struct {
	Addressed int32 `json:"addressed"`
	Sent int32 `json:"sent"`
	Executions int32 `json:"executions"`
	Rescheduled int32 `json:"rescheduled"`
	OptOuts int32 `json:"opt_outs"`
	MarketingOptOuts int32 `json:"marketing_opt_outs"`
	Unreachable int32 `json:"unreachable"`
	Reactance int32 `json:"reactance"`
	Errors int32 `json:"errors"`
	Delivered int32 `json:"delivered"`
	Read int32 `json:"read"`
}

// NewCampaignMetrics instantiates a new CampaignMetrics object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignMetrics(addressed int32, sent int32, executions int32, rescheduled int32, optOuts int32, marketingOptOuts int32, unreachable int32, reactance int32, errors int32, delivered int32, read int32) *CampaignMetrics {
	this := CampaignMetrics{}
	this.Addressed = addressed
	this.Sent = sent
	this.Executions = executions
	this.Rescheduled = rescheduled
	this.OptOuts = optOuts
	this.MarketingOptOuts = marketingOptOuts
	this.Unreachable = unreachable
	this.Reactance = reactance
	this.Errors = errors
	this.Delivered = delivered
	this.Read = read
	return &this
}

// NewCampaignMetricsWithDefaults instantiates a new CampaignMetrics object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignMetricsWithDefaults() *CampaignMetrics {
	this := CampaignMetrics{}
	return &this
}

// GetAddressed returns the Addressed field value
func (o *CampaignMetrics) GetAddressed() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Addressed
}

// GetAddressedOk returns a tuple with the Addressed field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetAddressedOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Addressed, true
}

// SetAddressed sets field value
func (o *CampaignMetrics) SetAddressed(v int32) {
	o.Addressed = v
}

// GetSent returns the Sent field value
func (o *CampaignMetrics) GetSent() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Sent
}

// GetSentOk returns a tuple with the Sent field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetSentOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Sent, true
}

// SetSent sets field value
func (o *CampaignMetrics) SetSent(v int32) {
	o.Sent = v
}

// GetExecutions returns the Executions field value
func (o *CampaignMetrics) GetExecutions() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Executions
}

// GetExecutionsOk returns a tuple with the Executions field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetExecutionsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Executions, true
}

// SetExecutions sets field value
func (o *CampaignMetrics) SetExecutions(v int32) {
	o.Executions = v
}

// GetRescheduled returns the Rescheduled field value
func (o *CampaignMetrics) GetRescheduled() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Rescheduled
}

// GetRescheduledOk returns a tuple with the Rescheduled field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetRescheduledOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Rescheduled, true
}

// SetRescheduled sets field value
func (o *CampaignMetrics) SetRescheduled(v int32) {
	o.Rescheduled = v
}

// GetOptOuts returns the OptOuts field value
func (o *CampaignMetrics) GetOptOuts() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.OptOuts
}

// GetOptOutsOk returns a tuple with the OptOuts field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetOptOutsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OptOuts, true
}

// SetOptOuts sets field value
func (o *CampaignMetrics) SetOptOuts(v int32) {
	o.OptOuts = v
}

// GetMarketingOptOuts returns the MarketingOptOuts field value
func (o *CampaignMetrics) GetMarketingOptOuts() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.MarketingOptOuts
}

// GetMarketingOptOutsOk returns a tuple with the MarketingOptOuts field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetMarketingOptOutsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MarketingOptOuts, true
}

// SetMarketingOptOuts sets field value
func (o *CampaignMetrics) SetMarketingOptOuts(v int32) {
	o.MarketingOptOuts = v
}

// GetUnreachable returns the Unreachable field value
func (o *CampaignMetrics) GetUnreachable() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Unreachable
}

// GetUnreachableOk returns a tuple with the Unreachable field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetUnreachableOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Unreachable, true
}

// SetUnreachable sets field value
func (o *CampaignMetrics) SetUnreachable(v int32) {
	o.Unreachable = v
}

// GetReactance returns the Reactance field value
func (o *CampaignMetrics) GetReactance() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Reactance
}

// GetReactanceOk returns a tuple with the Reactance field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetReactanceOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Reactance, true
}

// SetReactance sets field value
func (o *CampaignMetrics) SetReactance(v int32) {
	o.Reactance = v
}

// GetErrors returns the Errors field value
func (o *CampaignMetrics) GetErrors() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Errors
}

// GetErrorsOk returns a tuple with the Errors field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetErrorsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Errors, true
}

// SetErrors sets field value
func (o *CampaignMetrics) SetErrors(v int32) {
	o.Errors = v
}

// GetDelivered returns the Delivered field value
func (o *CampaignMetrics) GetDelivered() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Delivered
}

// GetDeliveredOk returns a tuple with the Delivered field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetDeliveredOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Delivered, true
}

// SetDelivered sets field value
func (o *CampaignMetrics) SetDelivered(v int32) {
	o.Delivered = v
}

// GetRead returns the Read field value
func (o *CampaignMetrics) GetRead() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Read
}

// GetReadOk returns a tuple with the Read field value
// and a boolean to check if the value has been set.
func (o *CampaignMetrics) GetReadOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Read, true
}

// SetRead sets field value
func (o *CampaignMetrics) SetRead(v int32) {
	o.Read = v
}

func (o CampaignMetrics) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignMetrics) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["addressed"] = o.Addressed
	toSerialize["sent"] = o.Sent
	toSerialize["executions"] = o.Executions
	toSerialize["rescheduled"] = o.Rescheduled
	toSerialize["opt_outs"] = o.OptOuts
	toSerialize["marketing_opt_outs"] = o.MarketingOptOuts
	toSerialize["unreachable"] = o.Unreachable
	toSerialize["reactance"] = o.Reactance
	toSerialize["errors"] = o.Errors
	toSerialize["delivered"] = o.Delivered
	toSerialize["read"] = o.Read
	return toSerialize, nil
}

type NullableCampaignMetrics struct {
	value *CampaignMetrics
	isSet bool
}

func (v NullableCampaignMetrics) Get() *CampaignMetrics {
	return v.value
}

func (v *NullableCampaignMetrics) Set(val *CampaignMetrics) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignMetrics) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignMetrics) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignMetrics(val *CampaignMetrics) *NullableCampaignMetrics {
	return &NullableCampaignMetrics{value: val, isSet: true}
}

func (v NullableCampaignMetrics) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignMetrics) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


